package de.fraunhofer.iem.app.configuration

import jakarta.annotation.PostConstruct
import jakarta.validation.constraints.NotBlank
import org.springframework.boot.context.properties.ConfigurationProperties
import org.springframework.boot.context.properties.ConfigurationPropertiesScan
import org.springframework.validation.annotation.Validated
import java.net.URI
import java.net.URL

@ConfigurationProperties(prefix = "opencode.api")
@ConfigurationPropertiesScan
@Validated
data class OpenCodeApiProperties(
    @field:NotBlank
    val basePath: String,
    @field:NotBlank
    val ort: String,
    val auth: String,
    val authApiKey: String
) {
    @PostConstruct
    fun postConstruct() {
        // There is no try catch block around the operations on purpose!
        // We want to throw here if this operations fail.
        URI.create(basePath)
    }
}
